-----------------------------------------------------------------------------
module Testbed(module PPrint,
               module Id,
               module Kind, module Type, module Pred, module Scheme,
               module Subst, module Unify,
               module Assump,
               module StdPrel,
               module Lit, module Pat, module TIMain, module TIProg,
               test, save) where

import PPrint
import Id
import Kind
import Type
import Pred
import Scheme
import Subst
import Unify
import Assump
import StdPrel
import Lit
import Pat
import TIMain
import TIProg

test       :: [Assump] -> [BindGroup] -> IO ()
test as bgs = putStr $ render $ vcat $ map pprint $ reverse $
              tiProgram' as bgs

save       :: String -> [Assump] -> [BindGroup] -> IO ()
save f as bgs
            = writeFile (f++".hs")
              ("module " ++ f ++ " where\n\
               \import Testbed\n\n\
               \defns" ++ f ++ "\n" ++
               render
                (text " = " <+>
                  brackets (fsep (punctuate comma (map pprint as')))) ++ "\n")
              where as' = reverse $ tiProgram' as bgs

-----------------------------------------------------------------------------
